﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel

Namespace ViewModel
    Public Class ConsumerListViewModel
        Inherits ViewModelBase


        Public Sub New()



            'Beispieldaten erstellen
            Dim TestDevices As New List(Of Model.Device) From {
                New Model.Device() With {.ID = 1, .Name = "Neonlampe (einfach)", .Description = "keine", .Power = 56, .DeviceGroupID = 1}, New Model.Device() With {.ID = 2, .Name = "Neonlampe (doppelt)", .Description = "keine", .Power = 112, .DeviceGroupID = 1},
                New Model.Device() With {.ID = 3, .Name = "PC", .Description = "Esprimo", .Power = 230, .DeviceGroupID = 2}, New Model.Device() With {.ID = 4, .Name = "Beamer", .Description = "Casio", .Power = 240, .DeviceGroupID = 2}}


            Dim TestDeviceGroups As New List(Of Model.DeviceGroup) From {
                New Model.DeviceGroup() With {.ID = 1, .Name = "Beleuchtung"}, New Model.DeviceGroup() With {.ID = 2, .Name = "Technik"}}
            Dim TestDeviceGroupsVM As New List(Of DeviceGroupViewModel)
            TestDeviceGroups.ForEach(Sub(x) TestDeviceGroupsVM.Add(New DeviceGroupViewModel(x)))

            Dim TestDevicesVM As New List(Of ViewModel.DeviceViewModel)


            For i As Integer = 0 To TestDevices.Count - 1
                TestDevicesVM.Add(New DeviceViewModel(TestDevices(i), TestDeviceGroupsVM))
            Next

            Dim TestTimeAreas As New List(Of Model.TimeArea) From {
                New Model.TimeArea() With {.ID = 1, .Name = "Nur an Schultagen"}, New Model.TimeArea() With {.ID = 2, .Name = "Immer an"}}
            Dim TestTimeAreasVM As New List(Of ViewModel.TimeAreaViewModel)

            For i As Integer = 0 To TestTimeAreas.Count - 1
                TestTimeAreasVM.Add(New TimeAreaViewModel(TestTimeAreas(i)))
            Next


            Dim TestRooms As New List(Of Model.Room) From {
                New Model.Room() With {.ID = 1, .RoomNumber = "002", .Floor = "0"}, New Model.Room() With {.ID = 2, .RoomNumber = "109", .Floor = "1"},
                New Model.Room() With {.ID = 3, .RoomNumber = "003", .Floor = "0"}, New Model.Room() With {.ID = 4, .RoomNumber = "214", .Floor = "2"}}
            Dim TestRoomsVM As New List(Of RoomViewModel)
            TestRooms.ForEach(Sub(x) TestRoomsVM.Add(New RoomViewModel(x)))

            Dim TestDataCollectors As New List(Of Model.DataCollector) From {
                New Model.DataCollector() With {.ID = 1, .Names = "Florian, Simon", .Grade = "9b"}, New Model.DataCollector() With {.ID = 2, .Grade = "9c", .Names = "Lukas, Finn"}}
            Dim TestDataCollectorsVM As New List(Of DataCollectorViewModel)
            TestDataCollectors.ForEach(Sub(x) TestDataCollectorsVM.Add(New DataCollectorViewModel(x)))

            Dim TestConsumer As New List(Of Model.Consumer) From {
                New Model.Consumer() With {.ID = 1, .DeviceID = 1, .RoomID = 2, .DeviceCount = 4, .DataCollectorID = 1, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 2, .DeviceID = 3, .RoomID = 1, .DeviceCount = 6, .DataCollectorID = 2, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 3, .DeviceID = 3, .RoomID = 4, .DeviceCount = 3, .DataCollectorID = 2, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 4, .DeviceID = 4, .RoomID = 4, .DeviceCount = 6, .DataCollectorID = 1, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 5, .DeviceID = 3, .RoomID = 2, .DeviceCount = 9, .DataCollectorID = 2, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 6, .DeviceID = 3, .RoomID = 2, .DeviceCount = 9, .DataCollectorID = 1, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 7, .DeviceID = 3, .RoomID = 1, .DeviceCount = 6, .DataCollectorID = 1, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 8, .DeviceID = 2, .RoomID = 3, .DeviceCount = 9, .DataCollectorID = 2, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 9, .DeviceID = 1, .RoomID = 2, .DeviceCount = 2, .DataCollectorID = 2, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 10, .DeviceID = 3, .RoomID = 3, .DeviceCount = 2, .DataCollectorID = 1, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 11, .DeviceID = 2, .RoomID = 1, .DeviceCount = 9, .DataCollectorID = 2, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 12, .DeviceID = 4, .RoomID = 2, .DeviceCount = 1, .DataCollectorID = 1, .TimeAreaID = 1}}

            AllConsumers = New ObservableCollection(Of ConsumerViewModel)
            TestConsumer.ForEach(Sub(x) AllConsumers.Add(New ConsumerViewModel(x, (TestDevicesVM, TestRoomsVM, TestDataCollectorsVM, TestTimeAreasVM, TestDeviceGroups))))
            SelectedConsumer = AllConsumers.FirstOrDefault()

            AllConsumersView = CollectionViewSource.GetDefaultView(AllConsumers)
            AllConsumersView.Filter = AddressOf AllConsumersView_Filter
        End Sub


        Private _allConsumers As ObservableCollection(Of ConsumerViewModel)
        Public Property AllConsumers As ObservableCollection(Of ConsumerViewModel)
            Get
                Return _allConsumers
            End Get
            Set(ByVal Value As ObservableCollection(Of ConsumerViewModel))
                _allConsumers = Value
                RaisePropertyChanged()
            End Set
        End Property

        Private _allConsumersView As ICollectionView
        Public Property AllConsumersView As ICollectionView
            Get
                Return _allConsumersView
            End Get
            Set(value As ICollectionView)
                _allConsumersView = value
                RaisePropertyChanged()
            End Set
        End Property

        Private _filterText As String
        Public Property FilterText As String
            Get
                Return _filterText
            End Get
            Set(value As String)
                _filterText = value
                AllConsumersView.Refresh()
                RaisePropertyChanged()
            End Set
        End Property

        Private Function AllConsumersView_Filter(obj As Object) As Boolean
            If String.IsNullOrEmpty(FilterText) Then Return True
            Dim currentConsumer As ConsumerViewModel = CType(obj, ConsumerViewModel)
            Dim roomnumberF As Boolean = currentConsumer.Room.RoomNumber.ToLower.Contains(FilterText.ToLower)
            Dim dataCollectorF As Boolean = currentConsumer.DataCollector.NamesAndGrade.ToLower.Contains(FilterText.ToLower)
            Dim deviceGroupF As Boolean = currentConsumer.Device.DeviceGroup.Name.ToLower.Contains(FilterText.ToLower)
            Dim deviceF As Boolean = currentConsumer.Device.Name.ToLower.Contains(FilterText.ToLower)


            If roomnumberF Or dataCollectorF Or deviceGroupF Or deviceF Then
                Return True
            Else
                Return False
            End If
        End Function



        Private _selectetConsumer As ConsumerViewModel
        Public Property SelectedConsumer As ConsumerViewModel
            Get
                Return _selectetConsumer
            End Get
            Set(value As ConsumerViewModel)
                _selectetConsumer = value
                RaisePropertyChanged()
            End Set
        End Property



    End Class
End Namespace
