﻿Imports ConsumerBeispiel


Namespace ViewModel
    Public Class DeviceViewModel
        Inherits ViewModel.ViewModelBase

        Private ReadOnly _deviceModel As Model.Device

        Public Sub New(deviceModel As Model.Device, aviableData As List(Of ViewModel.DeviceGroupViewModel))
            _aviableDeviceGroups = aviableData
            _deviceModel = deviceModel

            DeviceGroup = aviableData.Where(Function(x) x.ID = _deviceModel.DeviceGroupID).FirstOrDefault()

            Name = _deviceModel.Name
            Description = deviceModel.Description
            Power = deviceModel.Power
        End Sub


        Public ReadOnly Property ID As Integer
            Get
                Return _deviceModel.ID
            End Get
        End Property


        Private _Name As String
        Public Property Name As String
            Get
                Return _Name
            End Get
            Set(value As String)
                _Name = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _Description As String
        Public Property Description As String
            Get
                Return _Description
            End Get
            Set(value As String)
                _Description = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _Power As Double
        Public Property Power As Double
            Get
                Return _Power
            End Get
            Set(value As Double)
                _Power = value
                RaisePropertyChanged()
            End Set
        End Property


        Public ReadOnly Property NameAndPower As String
            Get
                Return Name + " - (" + Power.ToString() + " W) - " + DeviceGroup.Name
            End Get
        End Property




        Private _aviableDeviceGroups As List(Of ViewModel.DeviceGroupViewModel)
        Public Property aviableDeviceGroups As List(Of ViewModel.DeviceGroupViewModel)
            Get
                Return _aviableDeviceGroups
            End Get
            Set(value As List(Of ViewModel.DeviceGroupViewModel))
                _aviableDeviceGroups = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _deviceGroup As ViewModel.DeviceGroupViewModel
        Public Property DeviceGroup As ViewModel.DeviceGroupViewModel
            Get
                Return _deviceGroup
            End Get
            Set(value As ViewModel.DeviceGroupViewModel)
                _deviceGroup = value
                _deviceModel.DeviceGroupID = value.ID
                RaisePropertyChanged()
            End Set
        End Property

    End Class
End Namespace



